mia-2dmyomilles(1)

NAME
mia-2dmyomilles - Run a registration of a series of 2D images.

SYNOPSIS
mia-2dmyomilles -i <in-file> -o <out-file> [options]

DESCRIPTION
mia-2dmyomilles This program is use to run a modified version of the ICA based registration approach described in

    Milles et al. 'Fully Automated Motion Correction in First-Pass Myocardial Perfusion MR Image Sequences', Trans. Med. Imaging., 27(11), 1611-1621, 2008. (https://doi.org/10.1109/TMI.2008.928918)

 Changes include the extraction of the quasi-periodic movement in free breathingly acquired data sets and the option to run affine or rigid registration instead of the optimization of translations only.

OPTIONS

  File-IO

    -i --in-file=(input, required); string
        input perfusion data set

    -o --out-file=(output, required); string
        output perfusion data set

    -r --registered=
        file name base for registered files

    --save-references=
        save synthetic reference images to this file base

    --save-cropped=
        save cropped image set to this file

    --save-feature=
        save the features images resulting from the ICA and some intermediate images used for the RV-LV segmentation with the given file name base to PNG files. Also save the coefficients of the initial best and the final IC mixing matrix.

  Help & Info

    -V --verbose=warning
        verbosity of output, print messages of given level and higher priorities. Supported priorities starting at lowest level are:

        trace - Function call trace
        debug - Debug output
        info - Low level messages
        message - Normal messages
        warning - Warnings
        fail - Report test failures
        error - Report errors
        fatal - Report only fatal errors

    --copyright
        print copyright information

    -h --help
        print this help

    -? --usage
        print a short help

    --version
        print the version number and exit

  ICA

    --fastica=internal
        FastICA implementationto be used
         For supported plugins see PLUGINS:fastica/implementation

    -C --components=0
        ICA components 0 = automatic estimation

    --normalize
        normalized ICs

    --no-meanstrip
        don't strip the mean from the mixing curves

    -g --guess
        use initial guess for myocardial perfusion

    -s --segscale=1.4
        segment and scale the crop box around the LV (0=no segmentation)

    -k --skip=0
        skip images at the beginning of the series as they are of other modalities

    -m --max-ica-iter=400
        maximum number of iterations in ICA

    -E --segmethod=features
        Segmentation method

        delta-feature - difference of the feature images
        delta-peak - difference of the peak enhancement images
        features - feature images

  Processing

    --threads=-1
        Maxiumum number of threads to use for processing,This number should be lower or equal to the number of logical processor cores in the machine. (-1: automatic estimation).

  Registration

    -c --cost=ssd
        registration criterion

    -O --optimizer=gsl:opt=simplex,step=1.0
        Optimizer used for minimization
         For supported plugins see PLUGINS:minimizer/singlecost

    -f --transForm=rigid
        transformation type
         For supported plugins see PLUGINS:2dimage/transform

    -l --mg-levels=3
        multi-resolution levels

    -R --reference=-1
        Global reference all image should be aligned to. If set to a non-negative value, the images will be aligned to this references, and the cropped output image date will be injected into the original images. Leave at -1 if you don't care. In this case all images with be registered to a mean position of the movement

    -P --passes=2
        registration passes

PLUGINS: 1d/splinebc

mirror
    Spline interpolation boundary conditions that mirror on the boundary

    (no parameters)

repeat
    Spline interpolation boundary conditions that repeats the value at the boundary

    (no parameters)

zero
    Spline interpolation boundary conditions that assumes zero for values outside

    (no parameters)

PLUGINS: 1d/splinekernel

bspline
    B-spline kernel creation , supported parameters are:

    d = 3; int in [0, 5]
        Spline degree.

omoms
    OMoms-spline kernel creation, supported parameters are:

    d = 3; int in [3, 3]
        Spline degree.

PLUGINS: 2dimage/transform

affine
    Affine transformation (six degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

rigid
    Rigid transformations (i.e. rotation and translation, three degrees of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    rot-center = [[0,0]]; 2dfvector
        Relative rotation center, i.e. <0.5,0.5> corresponds to the center of the support rectangle.

rotation
    Rotation transformations (i.e. rotation about a given center, one degree of freedom)., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    rot-center = [[0,0]]; 2dfvector
        Relative rotation center, i.e. <0.5,0.5> corresponds to the center of the support rectangle.

spline
    Free-form transformation that can be described by a set of B-spline coefficients and an underlying B-spline kernel., supported parameters are:

    anisorate = [[0,0]]; 2dfvector
        anisotropic coefficient rate in pixels, nonpositive values will be overwritten by the 'rate' value..

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

    kernel = [bspline:d=3]; factory
        transformation spline kernel.. For supported plug-ins see PLUGINS:1d/splinekernel

    penalty = ; factory
        Transformation penalty term. For supported plug-ins see PLUGINS:2dtransform/splinepenalty

    rate = 10; float in [1, inf)
        isotropic coefficient rate in pixels.

translate
    Translation only (two degrees of freedom), supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

vf  This plug-in implements a transformation that defines a translation for each point of the grid defining the domain of the transformation., supported parameters are:

    imgboundary = mirror; factory
        image interpolation boundary conditions. For supported plug-ins see PLUGINS:1d/splinebc

    imgkernel = [bspline:d=3]; factory
        image interpolator kernel. For supported plug-ins see PLUGINS:1d/splinekernel

PLUGINS: 2dtransform/splinepenalty

divcurl
    divcurl penalty on the transformation, supported parameters are:

    curl = 1; float in [0, inf)
        penalty weight on curl.

    div = 1; float in [0, inf)
        penalty weight on divergence.

    norm = 0; bool
        Set to 1 if the penalty should be normalized with respect to the image size.

    weight = 1; float in (0, inf)
        weight of penalty energy.

PLUGINS: fastica/implementation

internal
    This is the MIA implementation of the FastICA algorithm.

    (no parameters)

itpp
    This is the IT++ implementation of the FastICA algorithm.

    (no parameters)

PLUGINS: minimizer/singlecost

gdas
    Gradient descent with automatic step size correction., supported parameters are:

    ftolr = 0; double in [0, inf)
        Stop if the relative change of the criterion is below..

    max-step = 2; double in (0, inf)
        Maximal absolute step size.

    maxiter = 200; uint in [1, inf)
        Stopping criterion: the maximum number of iterations.

    min-step = 0.1; double in (0, inf)
        Minimal absolute step size.

    xtola = 0.01; double in [0, inf)
        Stop if the inf-norm of the change applied to x is below this value..

gdsq
    Gradient descent with quadratic step estimation, supported parameters are:

    ftolr = 0; double in [0, inf)
        Stop if the relative change of the criterion is below..

    gtola = 0; double in [0, inf)
        Stop if the inf-norm of the gradient is below this value..

    maxiter = 100; uint in [1, inf)
        Stopping criterion: the maximum number of iterations.

    scale = 2; double in (1, inf)
        Fallback fixed step size scaling.

    step = 0.1; double in (0, inf)
        Initial step size.

    xtola = 0; double in [0, inf)
        Stop if the inf-norm of x-update is below this value..

gsl optimizer plugin based on the multimin optimizers of the GNU Scientific Library (GSL) https://www.gnu.org/software/gsl/, supported parameters are:

    eps = 0.01; double in (0, inf)
        gradient based optimizers: stop when |grad| < eps, simplex: stop when simplex size < eps..

    iter = 100; uint in [1, inf)
        maximum number of iterations.

    opt = gd; dict
        Specific optimizer to be used.. Supported values are:
            simplex - Simplex algorithm of Nelder and Mead
            cg-fr - Flecher-Reeves conjugate gradient algorithm
            cg-pr - Polak-Ribiere conjugate gradient algorithm
            bfgs - Broyden-Fletcher-Goldfarb-Shann
            bfgs2 - Broyden-Fletcher-Goldfarb-Shann (most efficient version)
            gd - Gradient descent.

    step = 0.001; double in (0, inf)
        initial step size.

    tol = 0.1; double in (0, inf)
        some tolerance parameter.

nlopt
    Minimizer algorithms using the NLOPT library, for a description of the optimizers please see 'http://ab-initio.mit.edu/wiki/index.php/NLopt_Algorithms', supported parameters are:

    ftola = 0; double in [0, inf)
        Stopping criterion: the absolute change of the objective value is below this value.

    ftolr = 0; double in [0, inf)
        Stopping criterion: the relative change of the objective value is below this value.

    higher = inf; double
        Higher boundary (equal for all parameters).

    local-opt = none; dict
        local minimization algorithm that may be required for the main minimization algorithm.. Supported values are:
            gn-direct - Dividing Rectangles
            gn-direct-l - Dividing Rectangles (locally biased)
            gn-direct-l-rand - Dividing Rectangles (locally biased, randomized)
            gn-direct-noscal - Dividing Rectangles (unscaled)
            gn-direct-l-noscal - Dividing Rectangles (unscaled, locally biased)
            gn-direct-l-rand-noscale - Dividing Rectangles (unscaled, locally biased, randomized)
            gn-orig-direct - Dividing Rectangles (original implementation)
            gn-orig-direct-l - Dividing Rectangles (original implementation, locally biased)
            ld-lbfgs-nocedal - None
            ld-lbfgs - Low-storage BFGS
            ln-praxis - Gradient-free Local Optimization via the Principal-Axis Method
            ld-var1 - Shifted Limited-Memory Variable-Metric, Rank 1
            ld-var2 - Shifted Limited-Memory Variable-Metric, Rank 2
            ld-tnewton - Truncated Newton
            ld-tnewton-restart - Truncated Newton with steepest-descent restarting
            ld-tnewton-precond - Preconditioned Truncated Newton
            ld-tnewton-precond-restart - Preconditioned Truncated Newton with steepest-descent restarting
            gn-crs2-lm - Controlled Random Search with Local Mutation
            ld-mma - Method of Moving Asymptotes
            ln-cobyla - Constrained Optimization BY Linear Approximation
            ln-newuoa - Derivative-free Unconstrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-newuoa-bound - Derivative-free Bound-constrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-neldermead - Nelder-Mead simplex algorithm
            ln-sbplx - Subplex variant of Nelder-Mead
            ln-bobyqa - Derivative-free Bound-constrained Optimization
            gn-isres - Improved Stochastic Ranking Evolution Strategy
            none - don't specify algorithm

    lower = -inf; double
        Lower boundary (equal for all parameters).

    maxiter = 100; int in [1, inf)
        Stopping criterion: the maximum number of iterations.

    opt = ld-lbfgs; dict
        main minimization algorithm. Supported values are:
            gn-direct - Dividing Rectangles
            gn-direct-l - Dividing Rectangles (locally biased)
            gn-direct-l-rand - Dividing Rectangles (locally biased, randomized)
            gn-direct-noscal - Dividing Rectangles (unscaled)
            gn-direct-l-noscal - Dividing Rectangles (unscaled, locally biased)
            gn-direct-l-rand-noscale - Dividing Rectangles (unscaled, locally biased, randomized)
            gn-orig-direct - Dividing Rectangles (original implementation)
            gn-orig-direct-l - Dividing Rectangles (original implementation, locally biased)
            ld-lbfgs-nocedal - None
            ld-lbfgs - Low-storage BFGS
            ln-praxis - Gradient-free Local Optimization via the Principal-Axis Method
            ld-var1 - Shifted Limited-Memory Variable-Metric, Rank 1
            ld-var2 - Shifted Limited-Memory Variable-Metric, Rank 2
            ld-tnewton - Truncated Newton
            ld-tnewton-restart - Truncated Newton with steepest-descent restarting
            ld-tnewton-precond - Preconditioned Truncated Newton
            ld-tnewton-precond-restart - Preconditioned Truncated Newton with steepest-descent restarting
            gn-crs2-lm - Controlled Random Search with Local Mutation
            ld-mma - Method of Moving Asymptotes
            ln-cobyla - Constrained Optimization BY Linear Approximation
            ln-newuoa - Derivative-free Unconstrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-newuoa-bound - Derivative-free Bound-constrained Optimization by Iteratively Constructed Quadratic Approximation
            ln-neldermead - Nelder-Mead simplex algorithm
            ln-sbplx - Subplex variant of Nelder-Mead
            ln-bobyqa - Derivative-free Bound-constrained Optimization
            gn-isres - Improved Stochastic Ranking Evolution Strategy
            auglag - Augmented Lagrangian algorithm
            auglag-eq - Augmented Lagrangian algorithm with equality constraints only
            g-mlsl - Multi-Level Single-Linkage (require local optimization and bounds)
            g-mlsl-lds - Multi-Level Single-Linkage (low-discrepancy-sequence, require local gradient based optimization and bounds)
            ld-slsqp - Sequential Least-Squares Quadratic Programming

    step = 0; double in [0, inf)
        Initial step size for gradient free methods.

    stop = -inf; double
        Stopping criterion: function value falls below this value.

    xtola = 0; double in [0, inf)
        Stopping criterion: the absolute change of all x-values is below this value.

    xtolr = 0; double in [0, inf)
        Stopping criterion: the relative change of all x-values is below this value.

EXAMPLE
Register the perfusion series given in 'segment.set' by using automatic ICA estimation. Skip two images at the beginning and otherwiese use the default parameters. Store the result in 'registered.set'.

mia-2dmyomilles -i segment.set -o registered.set -k 2

AUTHOR(s)
Gert Wollny

COPYRIGHT
This software is Copyright (c) 1999-2015 Leipzig, Germany and Madrid, Spain. It comes with ABSOLUTELY NO WARRANTY and you may redistribute it under the terms of the GNU GENERAL PUBLIC LICENSE Version 3 (or later). For more information run the program with the option '--copyright'.